        typedef int TElement;

        #ifndef _List_H
        #define _List_H

        struct Node;
        typedef struct Node *PtrToNode;
        typedef PtrToNode List;
        typedef PtrToNode Position;

        List MakeEmpty( List L );
        int IsEmpty( List L );
        int IsLast( Position P, List L );
        Position Find( TElement X, List L );
        void Delete( TElement X, List L );
        Position FindPrevious( TElement X, List L );
        void Insert( TElement X, List L, Position P );
        void DeleteList( List L );
        Position Header( List L );
        Position First( List L );
        Position Advance( Position P );
        TElement Retrieve( Position P );

        #endif    /* _List_H */
        
